=== debian/changelog ===
slic3r-prusa (2.4.0+dfsg-2) unstable; urgency=medium

  * [ee4ac72] Stop linking against cereal library.
    It doesn't exist and it's causing FTBFS. (Closes: #1005492)
  * [8f58b90] Refresh Stop-building-test_voronoi.cpp.patch

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 25 Feb 2022 16:24:09 +0800

slic3r-prusa (2.4.0+dfsg-1) unstable; urgency=medium

  * [a97954a] New upstream version 2.4.0+dfsg
  * [99e6096] Disable dh_dwz to get aeround "Too many DIEs" error
  * [a5849c1] Drop deleted file patterns from debian/copyright

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 28 Dec 2021 01:05:16 +0800

slic3r-prusa (2.3.3+dfsg-3) unstable; urgency=medium

  * [8929e18] Use packaged catch2 library.
    Thanks to Tobias Frost <tobi@debian.org> (Closes: #979826)
  * [be803cc] Build-dep on catch2 and drop tests/catch2 files
  * [1cd5cda] Drop Move-Catch-namespace-into-PrusaCatch.patch.
    This is no longer needed now that we're using the packaged catch library

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 23 Dec 2021 03:02:30 +0800

slic3r-prusa (2.3.3+dfsg-2) unstable; urgency=medium

  * [98cf206] Disable compilation of test_voronoi.cpp to workaround ftbfs
    (Closes: #984338)
  * [dc392ad] Remove src/miniz/*.cpp from debian/copyright
  * [4384784] Fix tpi.h path in debian/copyright

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 21 Nov 2021 02:05:09 +0800

slic3r-prusa (2.3.3+dfsg-1) experimental; urgency=medium

  * [e30ffae] New upstream version 2.3.3+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 19 Jul 2021 03:22:09 +0800

slic3r-prusa (2.3.2+dfsg-1) experimental; urgency=medium

  * [1d9bbbe] New upstream version 2.3.2+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 09 Jul 2021 01:55:59 +0800
